/*SIMPLE BANKING
 By : Lab Batch 44 */


#include<fstream>                                          // inclusion of header files
#include<string.h>                                         // for string related functions
#include<stdio.h>                                          // for standard input-output functions
#include<cstring>                                            
#include<iostream>
#define sz 100                                             // defining macro size=100

using namespace std ;

struct date                                                // structure 'date' to store the date
{
	int day;
	int month;
	int year;
};
date dt;                                                   // global variable 'dt'  
class account_holder                                         
{
	char name[sz];                                                  // name in character array
	int age;                                                            
	char sex;
	char address[sz];
	date transaction_date[sz];                                      // aray of dates in 'date' structure form
	float balance[sz];                                              // array of updated balance in float form
	unsigned long int account_number;                               // account number in long integer
	char contact_number[10];
	int tran_number;                                                // to keep track of no of tranitions
	//static int position;                                          // static member to assign account numbers
       
	
	
      public :
       
      account_holder()                                              // constructor function to initialize values on object creation
	  {
	        tran_number=0 ; 
	        //position++; 
	        account_number=12345000; 
	        
	        for(int k=0 ; k<sz ; k++ )
	        {
	            transaction_date[k].day=0;
	            transaction_date[k].month=0;
	            transaction_date[k].year=0;
	        }
	        for(int k=0;k<100;k++)
	        {
	            balance[k]=-1;
	        }        
	      }

       	void assign_account_no()
       	{
             FILE * infile;
             infile = fopen("account_no","r+b");
             fseek(infile,-8,SEEK_END);
             fread(&account_number,8,1,infile);
             account_number++;
             fclose(infile);
        }     
             
     	void ACCOUNT_MODIFY();
	     void input_acc_info() ;
     	unsigned long int  get_acc_number()
       	{  return account_number;  }

       	 


     	void deposit(float num , date dt)                              // to deposit and save updated balance 
		{                                                            // in next element of balance array
             tran_number++;                                                           
		       balance[tran_number]=balance[tran_number-1]+num;
		 
		       transaction_date[tran_number].day=dt.day;	              // save current tran. date
		       transaction_date[tran_number].month=dt.month;
		       transaction_date[tran_number].year=dt.year;
       	}


     	void withdraw(float num,date dt)                                         // to withdraw and save updated balance in next element of balance array
        {
         	tran_number++;
		      balance[tran_number]=balance[tran_number-1]-num;
		
		      transaction_date[tran_number].day=dt.day;	                  // save current tran. date
		      transaction_date[tran_number].month=dt.month;
		      transaction_date[tran_number].year=dt.year;
       	}
          	 

      float get_balance()    { return balance[] ; }

      date get_date_open()                                             //  to get initial date
         {
         	return transaction_date[0];
         } 

      date get_last_transaction()                                      //  to get last transaction date
	      {
		      for( int i=0 ; i<sz ; i++ )
		       {
			      if(transaction_date[i].day=0)
			         return transaction_date[i-1];
		      }
	      }	


      void ACCOUNT_DISPLAY();
      void ACCOUNT_DELETE()
	      {
		   balance[0]=0.0;
		   //account_number=00000000; 
		
	      }
   	void input_date();                                              // function to input date from user
   	void cal_si();                                                  // to cal simple interest 
	
};

int size = sizeof(account_holder);

//int account_holder :: position = 0 ;                                     // initialize static member


void account_holder :: ACCOUNT_MODIFY()
{
	char name1[sz],add[sz];
	int age1 , num[10]={} ,flag=0;
	cout<<"\n\nPress 0 to retain old values . . . \n";
	cout<<"\nEnter name : ";
	gets(name1);
	if(strcmp(name1,"0")!=0)
	 {
	 	strcpy(name,name1);
	 }
	
	cout<<"\nEnter contact_number ";
	gets(name1);
	if(strcmp(name1,"0")!=0)
	 {
	 	strcpy(contact_number,name1);
	 }
	

	cout<<"\nEnter age : ";
	cin>>age1;
	if(age1)
	 {
	 	age=age1; 
	 }

	cout<<"\nEnter address : ";
	gets(add);
	if(strcmp(add,"0")!=0)
	 {
	 	strcpy(address,add);
	 } 
}

void account_holder :: input_acc_info()
{
	int i=0 ;
    assign_account_no();
	cout<<"\nEnter name : ";                                     // taking name of user
	cin>>name;
	while(name[i])
   {
    for(i=0 ; name[i] ; i++)
    {
      if(name[i]<65 || name[i]>122)             //checking whether only alphabets are entered in name
      {
        cout<<"Invalid input"<<endl;
        cout<<"Only alphabets should be entered"<<endl;
        cout<<"\n\tEnter name : "<<endl;
      }
      else if(name[i]>90 && name[i]<97)
      {
           cout<<"Invalid input"<<endl;
           cout<<"Only alphabets should be entered"<<endl;
           cout<<"\nEnter name : ";
      }
     }
   }

	cout<<"\nEnter age :";
	cin>>age;

	cout<<"\nEnter contact number (10-digit): ";
	cin>>contact_number;
	cout<<"\nEnter sex(M/F) : ";                                  // taking input for sex
	cin>>sex;
	while(sex!='m' && sex!='f' && sex!='M' && sex!='F')           //checking whether input is valid
     { 
      cout<<"Invalid input."<<endl;
      cout<<"Retry."<<endl;
      cout<<"Enter your gender "<<endl;
      cin>>sex; 
     }


	cout<<"\nEnter address : ";
	cin>>address;

	input_date();
		
	cout<<"\nEnter initial balance : (>=1000)";                                                            // taking balance 
	cin>>balance[0];	
	if(balance[0]<1000)                                                                                       // checking if balance is less than 1000
	 {
	 while(balance[0]<1000)
	 {
	 	cout<<"\nWrong Input  .. \nPlease enter balance >=1000 ";
	 	cin>>balance[0];
	 }	
	 }
	cout<<"\n\n\tYOUR ACCOUNT HAS BEEN CREATED .. \nPress enter to view account details ..";

	ACCOUNT_DISPLAY();                                                                                      // displaying account information
}

void account_holder :: ACCOUNT_DISPLAY()
{
	int i ;
	cout<<"\n\tAccount number : "<<account_number;
	cout<<"\n\nName : "<<name
	    <<"\n\nSex : "<<sex
	    <<"\n\nAge : "<<age
	    <<"\n\nContact No. : ";
	cout<<contact_number;
	
	cout<<"\n\nAddress : "<<address
	    <<"\n\nBalance : "<<balance[0]

	    <<"\n\nDate OF account open :";
	cout<<transaction_date[0].day<<"/"<<transaction_date[0].month<<"/"<<transaction_date[0].year;
	 
	 
}


void account_holder :: input_date()
{
   int flag =0 ;
   do {
   cout<<"\nEnter Date : ";                    // taking date of account opening as input
	cout<<"\tEnter day : ";
	cin>>transaction_date[tran_number].day;
	cout<<"\n\tEnter month : ";
	cin>>transaction_date[tran_number].month;
	cout<<"\n\tEnter year : ";
	cin>>transaction_date[tran_number].year;

	if(transaction_date[tran_number].month<1||transaction_date[tran_number].month>12)         // checking if the month entered is valid
	{                                                             
       cout<<"Invalid date .. Now try again "; 
       flag=1;
    }

   if((transaction_date[tran_number].year%100)==0)                                             // condition to check date in a leap year 
   {
      if(transaction_date[tran_number].year%400==0)                                            // If the condition is true then the entered year is leap year 
      { 
   
         if(transaction_date[tran_number].month==2)                                            // if the entered month is february   
         { 
            if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>29)     // date should not more than 29
            {
               cout<<"Invalid date .. Now try again ";
               flag=1;
            }
         }

         if(transaction_date[tran_number].month<8 && transaction_date[tran_number].month>0)
         {
            if(transaction_date[tran_number].month%2==1)                                        // if entered month is jan/march/may/july
            {    
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>31)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
            if(transaction_date[tran_number].month%2==0 && transaction_date[tran_number].month!=2)                  // if entered month is april/jun
            {
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>30)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
           }

         }

         if(transaction_date[tran_number].month>7 && transaction_date[tran_number].month<=12)
         {

            if(transaction_date[tran_number].month%2==1)                                          // if entered month is september/nov. 
            {    
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>30)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
            if(transaction_date[tran_number].month%2==0)                                         // if entered month is august/oct./dec.
            {
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>31)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
         }

       }


      else                                                         //not a leap year
      {
         if(transaction_date[tran_number].month==2)
         { 
            if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>28)
            {
               cout<<"Invalid date .. Now try again "; flag=1;
            }
         }

         if(transaction_date[tran_number].month<8 && transaction_date[tran_number].month>0)
         {
            if(transaction_date[tran_number].month%2==1) 
            {    
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>31)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
            if(transaction_date[tran_number].month%2==0 && transaction_date[tran_number].month!=2)
            {
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>30)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
         }

         if(transaction_date[tran_number].month>7 && transaction_date[tran_number].month<=12)
         {    
            if(transaction_date[tran_number].month%2==1)
            {    
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>30)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
             }
            if(transaction_date[tran_number].month%2==0)
            {
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>31)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
         }

      }
   }
  else
   {
      if(transaction_date[tran_number].year%4==0)                                                     // leap year
      {
         if(transaction_date[tran_number].month==2)
         { 
            if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>29)
            {
               cout<<"Invalid date .. Now try again "; flag=1;
             }
         }

         if(transaction_date[tran_number].month<8 && transaction_date[tran_number].month>0)
         {       
            if(transaction_date[tran_number].month%2==1)
            {    
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>31)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
            if(transaction_date[tran_number].month%2==0 && transaction_date[tran_number].month!=2)
            {
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>30)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
          }

         if(transaction_date[tran_number].month>7 && transaction_date[tran_number].month<=12)
         {
            if(transaction_date[tran_number].month%2==1)
            {    
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>30)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
            if(transaction_date[tran_number].month%2==0)
            {
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>31)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }

          }

      }
      else                                                               // not a leap year
      {
         if(transaction_date[tran_number].month==2)
         { 
            if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>28)
            {
               cout<<"Invalid date .. Now try again "; flag=1;
            }
         }

         if(transaction_date[tran_number].month<8 && transaction_date[tran_number].month>0)
         {
             if(transaction_date[tran_number].month%2==1)
             {    
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>31)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
             }
             if(transaction_date[tran_number].month%2==0 && transaction_date[tran_number].month!=2)
             {
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>30)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
             }

         }

         if(transaction_date[tran_number].month>7 && transaction_date[tran_number].month<=12)
         {
            if(transaction_date[tran_number].month%2==1)
            {    
               if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>30)
               {
                  cout<<"Invalid date .. Now try again "; flag=1;
               }
            }
            if(transaction_date[tran_number].month%2==0)
            {
                if(transaction_date[tran_number].day<1||transaction_date[tran_number].day>31)
                {
                  cout<<"Invalid date .. Now try again "; flag=1;
                }
            }

         }

      }}}
      while ( flag==1 ) ;

}

FILE  * outfile , * infile ;                                           // declaration of file pointers

void ACCOUNT_CREATE();                                                 // global functions declaration
void ACCOUNT_DEPOSIT();
void ACCOUNT_WITHDRAW();
void ACCOUNT_MODIFY();
void ACCOUNT_DISPLAY();
void ACCOUNT_DELETE();



account_holder user;

unsigned long int acc_num,acc;
	
int main()
{
    
	int choice , i=0 , j ;float  amount ;
	char ch , str[10];
	
	
	do 
	   {                                                                 // displaying user menu
		cout << "Welcome to the Bank.\n Select an option.\n";
		cout << "	1- Create an account\n";
		cout << "	2- Make a deposit\n";
		cout << "	3- Make a withdrawl\n";
		cout << "	4- View account information\n";
		cout << "	5- Modify account information\n";
		cout << "	6- Delete Account\n";
		cout <<	" 	7- Exit \n";
		cin >> choice;
		switch(choice)
		{
			case 1 : 
				ACCOUNT_CREATE();			                        // calling the functions
				break;	
				
			
			case 2 :
            ACCOUNT_DEPOSIT();				
				break;

				 
			case 3 : 
				ACCOUNT_WITHDRAW();	 			   
				break;

						
			case 4 :
				ACCOUNT_DISPLAY();
				break;

			
			case 5 :
				ACCOUNT_MODIFY();
				break;



			case 6 :
				ACCOUNT_DELETE();  
				break;

			case 7 : 
				cout<<"\n\n\t!!! EXITING PROGRAM !!! \n\n";
				return 0;
				
				
			default :
				cout<<"\nINVALID INPUT .. TRY AGAIN .. ";
		}
		cout<<"\n\nTo get back to the main menu , press 'm' .. ";
		cin>>ch;                                                              // option to get back to main menu
	  
	}
	while(ch=='m'||ch=='M');
}







// function defintions
		
void ACCOUNT_CREATE()                                                             
{
            cout<<"\n\n\t\tACCOUNT OPENING ";                                           // writing records to the file
            user.input_acc_info();
            outfile=fopen("records.dat","ab+");
            if(outfile==NULL) { cout<<"error opening the file !!!! ";  }
            fwrite(&user,1,size,outfile);
				fclose(outfile);			 		    
}				

void ACCOUNT_DEPOSIT()
{
            float amount;
            cout<<"\n\n\tDEPOSIT COUNTER ";                                            // scanning to the file and 
				cout<<"\nEnter account number of user : ";                         // depositing amount in the balance of the corresponding user
				cin>>acc_num;
				infile=fopen("records.dat","r+b");
				if(infile==NULL)
                { cout<<"Error"; }
                cout<<"\nSuccessful";
	            fseek(infile,0,SEEK_SET);
				while( ! (feof(infile) ) )
				{
				   cout<<"\nsuccess";
               fread(&user,size,1,infile);
				   if( user.get_acc_number()==acc_num )
				   {
					   user.input_date();
					   //cout<<"date entered ";
					   cout<<"\nEnter the amount to be deposited : ";
					   cin>>amount;
					   user.deposit(amount,user.get_last_transaction());
					   fseek(infile,(-1*size),SEEK_CUR);
					   fwrite(&user,1,size,infile);
					   break;
				   }
				   
				   fseek(infile,size,SEEK_CUR);
				}   
				fclose(infile);
}				


void ACCOUNT_WITHDRAW()
{
            float amount;
            cout<<"\n\n\tWITHDRAWAL COUNTER ";
				cout<<"\nEnter account number of user : ";
				cin>>acc_num;
				infile=fopen("records.dat","r+b");
				if(infile==NULL)
                { cout<<"Error"; }
	            fseek(infile,0,SEEK_SET);
				while( ! (feof(infile) ) )
				{
				   fread(&user,size,1,infile);
				   if( user.get_acc_number()==acc_num )
				   {
					   cout<<"\nEnter the amount to be withdrawn : ";
					   cin>>amount;
					   user.withdraw(amount,user.get_last_transaction());
	                   fseek(infile,-size,SEEK_CUR);
					   fwrite(&user,1,size,infile);
					   break;
				   }
				   
				   fseek(infile,size,SEEK_CUR);
				}   
				fclose(infile);
}


void ACCOUNT_DISPLAY()
{
              cout<<"\n\n\tDISPLAY USER INFORMATION ";

			.	cout<<"\nEnter account number of user : ";
				cin>>acc_num;
				infile=fopen("records.dat","r+b");
				if(infile==NULL)
                { cout<<"Error"; }
                fseek(infile,0,SEEK_SET);
				while( ! (feof(infile) ) )
				{
				  
                  fread(&user,size,1,infile);
				  if( user.get_acc_number()==acc_num )
				   {
					   user.ACCOUNT_DISPLAY();                                // calling display function of corresponding user
				   }
				   
				}
				fclose(infile);
}	



void ACCOUNT_MODIFY()
{
            cout<<"\n\n\tMODIFY USER INFORMATION ";
			    cout<<"\nEnter account number of user : ";
				cin>>acc_num;
				infile=fopen("record.txt","r+b");
				if(outfile==NULL)
                { cout<<"Error"; }
                fseek(infile,0,SEEK_SET);
				while(  (feof(infile) ) )
				{
				   fread(&user,size,1,infile);                    
				   if( user.get_acc_number()==acc_num )
				   {              
					   user.ACCOUNT_MODIFY();                                      // calling modify function of corresponding user
					   fseek(infile,-size,SEEK_CUR);
					   fwrite(&user,1,size,infile);
					}
					fseek(infile,size,SEEK_CUR);
				}
				fclose(infile);
}



void ACCOUNT_DELETE()
{
            char ch;
            cout<<"\n\n\tACCOUNT DELETION ";
		 		cout<<"\nEnter account number of user : ";
				cin>>acc_num;
				infile=fopen("records.dat","r+b");
				if(infile==NULL) { cout<<"\n\tError opening the file !!! ";  }                // opening records.dat for reading/writing
				outfile=fopen("temp.dat","a+b");                                              // opening temp.dat for writing
				if(outfile==NULL) { cout<<"\n\tError opening the file !!! ";  }
            while( ! feof ( infile ) )
            {
               fread(&user,size,1,infile);
               if(user.get_acc_number()==acc_num)
               {
                  cout<<"\nAre you sure , you want to delete this account ? ( y/n)";               // confirmation message for deletion
                  cin>>ch;
                  while(!(ch=='y' || ch=='Y' || ch=='n' || ch=='N' ))
                  {
                     cout<<"\nEnter y/n only : ";
                     cin>>ch;
                  }
                  if(ch=='y' || ch=='Y')
                  {
                     cout<<"\nYour account , bearing account number "<<user.get_acc_number()<<" has been deleted .. ";
                  }
                }     
               else
               {
               	fwrite(&user,size,1,outfile);                                                 // writing to temp.dat in case acc num does'nt match
               }   
            }
            if(ch=='n' || ch=='N')
            {
            	remove("temp.dat");
            }	
            else
            {
            	remove("records.dat");                                                             // removing records.dat
            	rename("temp.dat","records.dat");                                                  // renaming temp.dat as records.dat
            }
            	
            fclose(infile);
            fclose(outfile);                
}
